#include <stdio.h>	// printf()
#include <stdlib.h>	// random()
#include <conio.h>	// getch()

//#define TESTLAUF

#define MAX_ARBEITEN		10000
#define MAX_EINZELARBEIT	20

#define VERGEBEN		-1
#define KEINE_GEFUNDEN		-2

// Hauptprogramm
int main()
{
 int n;
 int t[MAX_ARBEITEN];
 int Anzahl_Personen=1;
 int Arbeit_an_Person_vergeben=0;	// soviele min. muss die Person schuften
 int am_Besten_passende_Arbeit;
 int Gesamtzeit=25;
 float durchschnittliche_Arbeitszeit=0;
 int i,j;				// Schleifenzhlvariablen

 #ifndef TESTLAUF
 printf("Wieviele Arbeiten gibt es zu tun? ");
 scanf("%d",&n);
 #else
 n=10000;
 #endif

 #ifndef TESTLAUF
 printf("\nGib zu jeder Arbeit ihre voraussichtliche Dauer in Minuten an:\n");
 #else
 randomize();
 #endif

 for(i=0;i<n;i++)
 {
  #ifndef TESTLAUF

  printf("%d. Arbeit: ",i+1);
  scanf("%d",&t[i]);

  #else
  t[i]=random(MAX_EINZELARBEIT)+1;
  #endif

  // die gesamte Arbeit aufsummieren (fr die Statistik)
  durchschnittliche_Arbeitszeit+=t[i];
 }

 #ifndef TESTLAUF
 printf("Wieviel Zeit hat jede Person (in Minuten)? ");
 scanf("%d",&Gesamtzeit);
 #endif

 for(i=0;i<n;i++)
 {
  // suche am Besten passende Arbeit heraus:
  am_Besten_passende_Arbeit=KEINE_GEFUNDEN;		// noch keine gefunden

  for(j=0;j<n;j++)
  {
   // wenn die Arbeit nicht bereits vergeben ist und die Arbeitszeit der Person
   // nicht bersteigt...
   if((t[j]!=VERGEBEN)&&(t[j]<=Gesamtzeit-Arbeit_an_Person_vergeben))
   {
    // wenn noch keine Arbeit ausgesucht, dann nimm die erstbeste
    if(am_Besten_passende_Arbeit==KEINE_GEFUNDEN) am_Besten_passende_Arbeit=j;
    // sonst: nimm sie, wenn sie lnger dauert
    else if(t[j]>t[am_Besten_passende_Arbeit])
	am_Besten_passende_Arbeit=j;
   }
  }

  // keine passende Arbeit gefunden
  if(am_Besten_passende_Arbeit==KEINE_GEFUNDEN)
  {
   Anzahl_Personen++;
   Arbeit_an_Person_vergeben=0;
   i--;	// hier wurde noch keine Arbeit vergeben
  }
  else
  {
   // Arbeit der Person zuordnen...
   Arbeit_an_Person_vergeben+=t[am_Besten_passende_Arbeit];
   // ...und Arbeit als vergeben deklarieren
   t[am_Besten_passende_Arbeit]=VERGEBEN;
  }
 }

 durchschnittliche_Arbeitszeit/=Anzahl_Personen;

 printf("Man braucht %d Personen, die durchschnittlich\n"
	"%f Minuten arbeiten; somit ist jeder durchschnittlich\n"
	"zu %.0f Prozent ausgelastet.\nTaste...\n",
	Anzahl_Personen,durchschnittliche_Arbeitszeit,
	durchschnittliche_Arbeitszeit*100/Gesamtzeit);

 getch();

 return 0;
}
